﻿'
'  QuickMath ─ 超級無敵計計數
'
'  用途：使用者於30秒時間內完成簡單的四則運算‧
'

Public Class Form1

    Dim no1 As Integer '記錄兩個隨機數製作算式
    Dim no2 As Integer
    Dim op As Integer '記錄計算符號的隨機數，並以1 = +, 2 = -, 3 = *, 4 = /
    Dim time As Integer = 60 '記錄時間用的變量


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Randomize() '初始化隨機數

    End Sub

    Private Sub ResetExpression()   '重設算式的程序

        '算式由三項資料組成，分別為兩個數值及計算符號
        '
        '為能控制算式的難度，兩個數值必須符合以下要求：
        '1. 若為 + 數
        '   - 無特別要求
        '2. 若為 - 數
        '   - 為避免出現負數結果及為零的結果，no1必須大於no2
        '3. 若為 x 數
        '   - 乘數及被乘數均不可以為1
        '4. 若為 / 數
        '   - 被除數(no1)必須大於除數(no2)
        '   - 除數不可以為1
        '   - 計算的結果不可以有餘數

        Dim ok As Integer = 0 '若為0，則算式不符合要求；當算式符合要求，ok會改為1

        op = Int(Rnd() * 4) + 1 '產生計算符號所代表的隨機數

        While ok = 0
            no1 = Int(Rnd() * 10) + 1   '產生兩個隨機數
            no2 = Int(Rnd() * 10) + 1

            '算式檢查，若符合上述的要求，便把變量ok改為1，否則重新產生兩個隨機數。
            If (op = 1) Or (op = 2 And (no1 > no2)) Or ((op = 3) And (no1 <> 1) And (no2 <> 1)) Or (op = 4 And (no1 > no2) And (no2 <> 1) And (no1 Mod no2 = 0)) Then
                ok = 1
            End If

        End While

    End Sub

    Private Sub DisplayExpression()

        '用以顯示算式於視窗內的程序

        Label1.Text = no1
        Label2.Text = no2

        '按照下列的規則及根據記錄於op的隨機數顯示合適的計算符號於Label3內
        '   1 = +
        '   2 = -
        '   3 = *
        '   4 = /
        If op = 1 Then
            Label3.Text = "+"
        ElseIf op = 2 Then
            Label3.Text = "-"
        ElseIf op = 3 Then
            Label3.Text = "x"
        ElseIf op = 4 Then
            Label3.Text = "/"
        End If

    End Sub


    Private Sub TextBox1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TextBox1.KeyDown

        '捕捉由TextBox1引發的按鍵盤事件

        '容許使用都直接透過鍵盤的Enter輸入答案
        'VB以 Keys.Enter代表Enter鍵的ASCII值

        '流程：
        '是否下按Enter及TextBox1是否為空
        '是 → 未有任何輸入，不作處理
        '否 → 檢查輸入是否數值
        '      是 → 檢查答案，記錄對錯及重設算式
        '      否 → 輸入包含數值以外的字否，清除TextBox1

        If e.KeyCode = Keys.Enter And TextBox1.Text <> "" Then  '檢查有否按Enter及TextBox1是否為空
            If IsNumeric(TextBox1.Text) Then    '檢查TextBox1的輸入是否數值
                If ((op = 1) And (no1 + no2 = TextBox1.Text)) Or _
                   ((op = 2) And (no1 - no2 = TextBox1.Text)) Or _
                   ((op = 3) And (no1 * no2 = TextBox1.Text)) Or _
                   ((op = 4) And (no1 / no2 = TextBox1.Text)) Then
                    Label5.Text = Label5.Text + 1
                Else
                    Label6.Text = Label6.Text + 1
                End If
                TextBox1.Clear()    '清除TextBox1，與 TextBox1.Text = "" 相同
                ResetExpression()   '重設隨機數及計算符號
                DisplayExpression() '顯示算式
            Else    'TextBox1的輸入並非數值
                TextBox1.Clear()
            End If
        End If

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        time -= 1
        Label7.Text = time
        If time <= 0 Then
            TextBox1.Enabled = False
            Timer1.Stop()
        End If

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Timer2.Start()
        Label8.Visible = True
        Button1.Enabled = False

    End Sub


    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick

        'Timer2：用以作遊戲開始前的倒數，倒數時於Label8內顯示3-2-1

        Label8.Text = Label8.Text - 1

        '倒數完畢時的指令
        If Label8.Text = 0 Then
            Label8.Visible = False  '隱藏Label8
            Timer2.Stop()           '
            ResetExpression()
            DisplayExpression()
            TextBox1.Enabled = True
            TextBox1.Focus()
            Timer1.Start()
        End If

    End Sub

End Class
